/*
	Paul Hlivko -- paul@hlivko.com -- 11/28/00
	
	This project will allow the user(s) to choose how many players they want and what each players
	name is. Then change screen, play Yatzee, and finally goto a winning screen with the winning
	player's name and a start new game button.
*/

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class TheApplet extends Applet implements ActionListener
{
	//Declaring all data members for theApplet class
	private Button roller, startNewGame, playYatzee;
	private Scoring scoreboard;
	private Vector diceVector;
	private Checkbox zeroCheckbox, oneCheckbox, twoCheckbox, threeCheckbox, fourCheckbox;
	private Button ones, twos, threes, fours, fives, sixes, three_of_a_kind, four_of_a_kind, full_house, small_straight, large_straight, yatzee, chance;
	private TextField onesText1, twosText1, threesText1, foursText1, fivesText1, sixesText1, three_of_a_kind_text1, four_of_a_kind_text1, full_house_text1, small_straight_text1, large_straight_text1, yatzeeText1, chanceText1;
	private TextField onesText2, twosText2, threesText2, foursText2, fivesText2, sixesText2, three_of_a_kind_text2, four_of_a_kind_text2, full_house_text2, small_straight_text2, large_straight_text2, yatzeeText2, chanceText2;
	private TextField onesText3, twosText3, threesText3, foursText3, fivesText3, sixesText3, three_of_a_kind_text3, four_of_a_kind_text3, full_house_text3, small_straight_text3, large_straight_text3, yatzeeText3, chanceText3;
	private TextField onesText4, twosText4, threesText4, foursText4, fivesText4, sixesText4, three_of_a_kind_text4, four_of_a_kind_text4, full_house_text4, small_straight_text4, large_straight_text4, yatzeeText4, chanceText4;			
	private TextField name_of_player_one, name_of_player_two, name_of_player_three, name_of_player_four;
	private Choice number_of_players;
	private Label openingLabel;
	private Image buffer;
	private Graphics pad; 
	private Die die;
	private String playerOneName, playerTwoName, playerThreeName, playerFourName, winningPlayerName; 
	private boolean openingScreen, gameScreen, winningScreen;
	private int    result0, result1, result2, result3, result4;
	private int    totalOfDice, total, n, rollNumber, numberOfPlayers, activePlayer;
	private int    totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1;
	private int    totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2;
	private int    totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3;
	private int    totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4;			
	private int    playerOneTotal, playerTwoTotal, playerThreeTotal, playerFourTotal;
	private int    onesCount, twosCount, threesCount, foursCount, fivesCount, sixesCount;
	private int    onePlayerTurnCount, twoPlayerTurnCount, threePlayerTurnCount, fourPlayerTurnCount;
	   
      

	
	public void init() {
	   //sets the layout and general background color
       setLayout(null);
       setBackground(Color.yellow.darker());
       
       //initializes the three booleans for the different screens
       openingScreen = true;
       gameScreen = false;
       winningScreen = false;
       
       //Start - Adding checkboxes for the Dice (are not visible at this point)
       zeroCheckbox = new Checkbox();
       zeroCheckbox.setBounds(32,75,40,30);
       add(zeroCheckbox);
       zeroCheckbox.setVisible(false);
       oneCheckbox = new Checkbox();
       oneCheckbox.setBounds(135,75,40,30);
       add(oneCheckbox);
       oneCheckbox.setVisible(false);
       twoCheckbox = new Checkbox();
       twoCheckbox.setBounds(241,75,40,30);
       add(twoCheckbox);
       twoCheckbox.setVisible(false);
       threeCheckbox = new Checkbox();
       threeCheckbox.setBounds(348,75,40,30);
       add(threeCheckbox);
       threeCheckbox.setVisible(false);
       fourCheckbox = new Checkbox();
       fourCheckbox.setBounds(452,75,40,30);
       add(fourCheckbox);
       fourCheckbox.setVisible(false);
       //End
       
       //Instantiates and adds the Roller Button which rolls the dice (is not visible as this point)       
       roller = new Button("Jeter les ds !");
       roller.setBounds(295, 115, 100, 30);
       add(roller);
       roller.setVisible(false);
       
       //Start- Adding the buttons to calculate the total points for each roll (are not visible at this point)
       ones = new Button("Un");
       ones.setBounds(10,120,150,20);
       add(ones);
       ones.setVisible(false);
       twos = new Button("Deux");
       twos.setBounds(10,140,150,20);
       add(twos);
       twos.setVisible(false);
       threes = new Button("Trois");
       threes.setBounds(10,160,150,20);
       add(threes);
       threes.setVisible(false);
       fours = new Button("Quatre");
       fours.setBounds(10,180,150,20);
       add(fours);
       fours.setVisible(false);
       fives = new Button("Cinq");
       fives.setBounds(10,200,150,20);
       add(fives);
       fives.setVisible(false);
       sixes = new Button("Six");
       sixes.setBounds(10,220,150,20);
       add(sixes);
       sixes.setVisible(false);
       three_of_a_kind = new Button("Brelan");
       three_of_a_kind.setBounds(10,240,150,20);
       add(three_of_a_kind);
       three_of_a_kind.setVisible(false);
       four_of_a_kind = new Button("Carr");
       four_of_a_kind.setBounds(10,260,150,20);
       add(four_of_a_kind);
       four_of_a_kind.setVisible(false);
       full_house = new Button("Full");
       full_house.setBounds(10,280,150,20);
       add(full_house);
       full_house.setVisible(false);
       small_straight = new Button("Petite Suite");
       small_straight.setBounds(10,300,150,20);
       add(small_straight);
       small_straight.setVisible(false);
       large_straight = new Button("Grande Suite");
       large_straight.setBounds(10,320,150,20);
       add(large_straight);
       large_straight.setVisible(false);
       yatzee = new Button("Yatzee");
       yatzee.setBounds(10,340,150,20);
       add(yatzee);
       yatzee.setVisible(false);
       chance = new Button("Chance");
       chance.setBounds(10,360,150,20);
       add(chance);
       chance.setVisible(false);
       //End
       
       
       //Start- Adds all of the TextFields for four players (are not visible at this point)
       //player one
       onesText1 = new TextField();
       onesText1.setBounds(160,120,30,20);
       onesText1.setBackground(Color.white);
       add(onesText1);
       onesText1.setVisible(false);
       twosText1 = new TextField();
       twosText1.setBounds(160,140,30,20);
       twosText1.setBackground(Color.white);
       add(twosText1);
       twosText1.setVisible(false);
       threesText1 = new TextField();
       threesText1.setBounds(160,160,30,20);
       threesText1.setBackground(Color.white);
       add(threesText1);
       threesText1.setVisible(false);
       foursText1 = new TextField();
       foursText1.setBounds(160,180,30,20);
       foursText1.setBackground(Color.white);
       add(foursText1);
       foursText1.setVisible(false);
       fivesText1 = new TextField();
       fivesText1.setBounds(160,200,30,20);
       fivesText1.setBackground(Color.white);
       add(fivesText1);
       fivesText1.setVisible(false);
       sixesText1 = new TextField();
       sixesText1.setBounds(160,220,30,20);
       sixesText1.setBackground(Color.white);
       add(sixesText1);
       sixesText1.setVisible(false);
       three_of_a_kind_text1 = new TextField();
       three_of_a_kind_text1.setBounds(160,240,30,20);
       three_of_a_kind_text1.setBackground(Color.white);
       add(three_of_a_kind_text1);
       three_of_a_kind_text1.setVisible(false);
       four_of_a_kind_text1 = new TextField();
       four_of_a_kind_text1.setBounds(160,260,30,20);
       four_of_a_kind_text1.setBackground(Color.white);
       add(four_of_a_kind_text1);
       four_of_a_kind_text1.setVisible(false);
       full_house_text1 = new TextField();
       full_house_text1.setBounds(160,280,30,20);
       full_house_text1.setBackground(Color.white);
       add(full_house_text1);
       full_house_text1.setVisible(false);
       small_straight_text1 = new TextField();
       small_straight_text1.setBounds(160,300,30,20);
       small_straight_text1.setBackground(Color.white);
       add(small_straight_text1);
       small_straight_text1.setVisible(false);
       large_straight_text1 = new TextField();
       large_straight_text1.setBounds(160,320,30,20);
       large_straight_text1.setBackground(Color.white);
       add(large_straight_text1);
       large_straight_text1.setVisible(false);
       yatzeeText1 = new TextField();
       yatzeeText1.setBounds(160,340,30,20);
       yatzeeText1.setBackground(Color.white);
       add(yatzeeText1);
       yatzeeText1.setVisible(false);
       chanceText1 = new TextField();
       chanceText1.setBounds(160,360,30,20);
       chanceText1.setBackground(Color.white);
       add(chanceText1);
       chanceText1.setVisible(false);
       //player two
       onesText2 = new TextField();
       onesText2.setBounds(190,120,30,20);
       onesText2.setBackground(Color.white);
       add(onesText2);
       onesText2.setVisible(false);
       twosText2 = new TextField();
       twosText2.setBounds(190,140,30,20);
       twosText2.setBackground(Color.white);
       add(twosText2);
       twosText2.setVisible(false);
       threesText2 = new TextField();
       threesText2.setBounds(190,160,30,20);
       threesText2.setBackground(Color.white);
       add(threesText2);
       threesText2.setVisible(false);
       foursText2 = new TextField();
       foursText2.setBounds(190,180,30,20);
       foursText2.setBackground(Color.white);
       add(foursText2);
       foursText2.setVisible(false);
       fivesText2 = new TextField();
       fivesText2.setBounds(190,200,30,20);
       fivesText2.setBackground(Color.white);
       add(fivesText2);
       fivesText2.setVisible(false);
       sixesText2 = new TextField();
       sixesText2.setBounds(190,220,30,20);
       sixesText2.setBackground(Color.white);
       add(sixesText2);
       sixesText2.setVisible(false);
       three_of_a_kind_text2 = new TextField();
       three_of_a_kind_text2.setBounds(190,240,30,20);
       three_of_a_kind_text2.setBackground(Color.white);
       add(three_of_a_kind_text2);
       three_of_a_kind_text2.setVisible(false);
       four_of_a_kind_text2 = new TextField();
       four_of_a_kind_text2.setBounds(190,260,30,20);
       four_of_a_kind_text2.setBackground(Color.white);
       add(four_of_a_kind_text2);
       four_of_a_kind_text2.setVisible(false);
       full_house_text2 = new TextField();
       full_house_text2.setBounds(190,280,30,20);
       full_house_text2.setBackground(Color.white);
       add(full_house_text2);
       full_house_text2.setVisible(false);
       small_straight_text2 = new TextField();
       small_straight_text2.setBounds(190,300,30,20);
       small_straight_text2.setBackground(Color.white);
       add(small_straight_text2);
       small_straight_text2.setVisible(false);
       large_straight_text2 = new TextField();
       large_straight_text2.setBounds(190,320,30,20);
       large_straight_text2.setBackground(Color.white);
       add(large_straight_text2);
       large_straight_text2.setVisible(false);
       yatzeeText2 = new TextField();
       yatzeeText2.setBounds(190,340,30,20);
       yatzeeText2.setBackground(Color.white);
       add(yatzeeText2);
       yatzeeText2.setVisible(false);
       chanceText2 = new TextField();
       chanceText2.setBounds(190,360,30,20);
       chanceText2.setBackground(Color.white);
       add(chanceText2);
       chanceText2.setVisible(false);
       //player three
       onesText3 = new TextField();
       onesText3.setBounds(220,120,30,20);
       onesText3.setBackground(Color.white);
       add(onesText3);
       onesText3.setVisible(false);
       twosText3 = new TextField();
       twosText3.setBounds(220,140,30,20);
       twosText3.setBackground(Color.white);
       add(twosText3);
       twosText3.setVisible(false);
       threesText3 = new TextField();
       threesText3.setBounds(220,160,30,20);
       threesText3.setBackground(Color.white);
       add(threesText3);
       threesText3.setVisible(false);
       foursText3 = new TextField();
       foursText3.setBounds(220,180,30,20);
       foursText3.setBackground(Color.white);
       add(foursText3);
       foursText3.setVisible(false);
       fivesText3 = new TextField();
       fivesText3.setBounds(220,200,30,20);
       fivesText3.setBackground(Color.white);
       add(fivesText3);
       fivesText3.setVisible(false);
       sixesText3 = new TextField();
       sixesText3.setBounds(220,220,30,20);
       sixesText3.setBackground(Color.white);
       add(sixesText3);
       sixesText3.setVisible(false);
       three_of_a_kind_text3 = new TextField();
       three_of_a_kind_text3.setBounds(220,240,30,20);
       three_of_a_kind_text3.setBackground(Color.white);
       add(three_of_a_kind_text3);
       three_of_a_kind_text3.setVisible(false);
       four_of_a_kind_text3 = new TextField();
       four_of_a_kind_text3.setBounds(220,260,30,20);
       four_of_a_kind_text3.setBackground(Color.white);
       add(four_of_a_kind_text3);
       four_of_a_kind_text3.setVisible(false);
       full_house_text3 = new TextField();
       full_house_text3.setBounds(220,280,30,20);
       full_house_text3.setBackground(Color.white);
       add(full_house_text3);
       full_house_text3.setVisible(false);
       small_straight_text3 = new TextField();
       small_straight_text3.setBounds(220,300,30,20);
       small_straight_text3.setBackground(Color.white);
       add(small_straight_text3);
       small_straight_text3.setVisible(false);
       large_straight_text3 = new TextField();
       large_straight_text3.setBounds(220,320,30,20);
       large_straight_text3.setBackground(Color.white);
       add(large_straight_text3);
       large_straight_text3.setVisible(false);
       yatzeeText3 = new TextField();
       yatzeeText3.setBounds(220,340,30,20);
       yatzeeText3.setBackground(Color.white);
       add(yatzeeText3);
       yatzeeText3.setVisible(false);
       chanceText3 = new TextField();
       chanceText3.setBounds(220,360,30,20);
       chanceText3.setBackground(Color.white);
       add(chanceText3);
       chanceText3.setVisible(false);
       //player four
       onesText4 = new TextField();
       onesText4.setBounds(250,120,30,20);
       onesText4.setBackground(Color.white);
       add(onesText4);
       onesText4.setVisible(false);
       twosText4 = new TextField();
       twosText4.setBounds(250,140,30,20);
       twosText4.setBackground(Color.white);
       add(twosText4);
       twosText4.setVisible(false);
       threesText4 = new TextField();
       threesText4.setBounds(250,160,30,20);
       threesText4.setBackground(Color.white);
       add(threesText4);
       threesText4.setVisible(false);
       foursText4 = new TextField();
       foursText4.setBounds(250,180,30,20);
       foursText4.setBackground(Color.white);
       add(foursText4);
       foursText4.setVisible(false);
       fivesText4 = new TextField();
       fivesText4.setBounds(250,200,30,20);
       fivesText4.setBackground(Color.white);
       add(fivesText4);
       fivesText4.setVisible(false);
       sixesText4 = new TextField();
       sixesText4.setBounds(250,220,30,20);
       sixesText4.setBackground(Color.white);
       add(sixesText4);
       sixesText4.setVisible(false);
       three_of_a_kind_text4 = new TextField();
       three_of_a_kind_text4.setBounds(250,240,30,20);
       three_of_a_kind_text4.setBackground(Color.white);
       add(three_of_a_kind_text4);
       three_of_a_kind_text4.setVisible(false);
       four_of_a_kind_text4 = new TextField();
       four_of_a_kind_text4.setBounds(250,260,30,20);
       four_of_a_kind_text4.setBackground(Color.white);
       add(four_of_a_kind_text4);
       four_of_a_kind_text4.setVisible(false);
       full_house_text4 = new TextField();
       full_house_text4.setBounds(250,280,30,20);
       full_house_text4.setBackground(Color.white);
       add(full_house_text4);
       full_house_text4.setVisible(false);
       small_straight_text4 = new TextField();
       small_straight_text4.setBounds(250,300,30,20);
       small_straight_text4.setBackground(Color.white);
       add(small_straight_text4);
       small_straight_text4.setVisible(false);
       large_straight_text4 = new TextField();
       large_straight_text4.setBounds(250,320,30,20);
       large_straight_text4.setBackground(Color.white);
       add(large_straight_text4);
       large_straight_text4.setVisible(false);
       yatzeeText4 = new TextField();
       yatzeeText4.setBounds(250,340,30,20);
       yatzeeText4.setBackground(Color.white);
       add(yatzeeText4);
       yatzeeText4.setVisible(false);
       chanceText4 = new TextField();
       chanceText4.setBounds(250,360,30,20);
       chanceText4.setBackground(Color.white);
       add(chanceText4);
       chanceText4.setVisible(false);
       //Ends
       
       //Sets the value for the results of the Dice when they are rolled  
       result0 = 0;
       result1 = 0;
       result2 = 0;
       result3 = 0;
       result4 = 0;
       
       //Sets the total value of all of the Dice
       totalOfDice = 0;
       
       //Sets the rollNumber so the dice cannot be rolled more than 3 times in a turn
       rollNumber = 0;
       
       total = 0;
       
	   //Creates a double buffer solution so the screen will not flicker
 	   buffer = createImage(size().width,size().height);
       pad = buffer.getGraphics();
       
       //Sets the default names for all of the players
       playerOneName = new String("Nom du joueur 1");
       playerTwoName = new String("Nom du joueur 2");
       playerThreeName = new String("Nom du joueur 3");
       playerFourName = new String("Nom du joueur 4");
       
       //Sets the value for how many of each number are on the Dice 
       onesCount = 0;
       twosCount = 0;
       threesCount = 0;
       foursCount = 0;
       fivesCount = 0;
       sixesCount = 0;
       
       //Sets the player turn count so the Applet knows when the game is over
       onePlayerTurnCount = 0;
       twoPlayerTurnCount = 0;
       threePlayerTurnCount = 0;
       fourPlayerTurnCount = 0;
       
       //Start - Instantiates the Dice but does not show them at this point
       //Also places the Dice in a Vector
       diceVector = new Vector();
       die = new Die(10, 10, 60);
       diceVector.addElement(die);
       
       
       die = new Die(115, 10, 60);
       diceVector.addElement(die);
       
       
       die = new Die(220, 10, 60);
       diceVector.addElement(die);
      
       
       die = new Die(325, 10, 60);
       diceVector.addElement(die);
       
       
       die = new Die(430, 10, 60);
       diceVector.addElement(die);
       
       int i;
       for(i=0; i<diceVector.size(); i++){
       Die tempdie = (Die) diceVector.elementAt(i);
       add(tempdie);
       }
       //makes the dice not visible       
       int r;
       for(r=0; r<diceVector.size(); r++){
       Die dietemp2 = (Die) diceVector.elementAt(r);
       dietemp2.makeInvisible();
       }
       //End
       
                     
       //Start- Instantiates all of the Opening Screen Items
       playYatzee = new Button("Jouer");
       playYatzee.setBounds(200, 300, 100, 25);
       add(playYatzee);
       
       name_of_player_one = new TextField(playerOneName);
       name_of_player_one.setForeground(Color.black);
	   name_of_player_one.setBackground(Color.white);
       name_of_player_one.setBounds(150, 100, 200, 25);
       add(name_of_player_one);
       
       name_of_player_two = new TextField(playerTwoName);
       name_of_player_two.setForeground(Color.black);
	   name_of_player_two.setBackground(Color.white);
       name_of_player_two.setBounds(150, 135, 200, 25);
       add(name_of_player_two);
       
       name_of_player_three = new TextField(playerThreeName);
	   name_of_player_three.setForeground(Color.black);
	   name_of_player_three.setBackground(Color.white);
       name_of_player_three.setBounds(150, 170, 200, 25);
       add(name_of_player_three);
       
       name_of_player_four = new TextField(playerFourName);
       name_of_player_four.setForeground(Color.black);
	   name_of_player_four.setBackground(Color.white);
       name_of_player_four.setBounds(150, 205, 200, 25);
       add(name_of_player_four);
       
       number_of_players = new Choice();
       number_of_players.add("1");
       number_of_players.add("2");
       number_of_players.add("3");
       number_of_players.add("4");
       number_of_players.setBounds(320, 60, 35, 30);
       add(number_of_players);
       
       openingLabel = new Label("Nombre de joueurs");
       openingLabel.setBounds(150, 60, 160, 30);
       openingLabel.setForeground(Color.white);
       openingLabel.setBackground(Color.black);
       openingLabel.setFont(new Font("SanSerif", Font.BOLD, 12));
       add(openingLabel);
       //End 
       
       //Start- Instantiates all of the Winning/Ending Screen
       startNewGame = new Button("Recommencer");
       startNewGame.setBounds(200, 250, 125, 30);
       add(startNewGame);
       startNewGame.setVisible(false);
       //End     
    
       //Adds action listeners to all of the buttons
       roller.addActionListener(this);
       playYatzee.addActionListener(this);
       startNewGame.addActionListener(this);    
    
	
	} 
	
	public void paint( Graphics p ) {
	 
	 	System.out.println("openingScreen = " + openingScreen);
	 	System.out.println("gameScreen = " + gameScreen);
	 	System.out.println("winningScreen = " + winningScreen);
	 	
	 	//Drawn for the opening Screen
		if(openingScreen == true){
		pad.setColor(Color.black);
		pad.fillRect(0,0,500,400);
		}
		
		//Drawn for the game Screen
		if(gameScreen == true){
		pad.setColor(Color.yellow.darker());
     	pad.fillRect(0,0,500,400);
     	scoreboard.drawScoreBoard(pad);
     	}
     	
     	//Drawn for the winning Screen
     	if(winningScreen == true){
     	
     	pad.setColor(Color.white);
     	pad.fillRect(0,0,500,400);
     	pad.setColor(Color.black);
     	pad.drawString(winningPlayerName + " a gagn le jeu.", 180, 100);
       
        //Start- makes all of the components not visible
       	zeroCheckbox.setVisible(false);
       	oneCheckbox.setVisible(false);
       	twoCheckbox.setVisible(false);
       	threeCheckbox.setVisible(false);
       	fourCheckbox.setVisible(false);
       
       
       	ones.setVisible(false);
       	twos.setVisible(false);
       	threes.setVisible(false);
       	fours.setVisible(false);
       	fives.setVisible(false);
      	sixes.setVisible(false);
       	three_of_a_kind.setVisible(false);
       	four_of_a_kind.setVisible(false);
       	full_house.setVisible(false);
       	small_straight.setVisible(false);
       	large_straight.setVisible(false);
       	yatzee.setVisible(false);
       	chance.setVisible(false);
       
       
       	onesText1.setVisible(false);
       	twosText1.setVisible(false);
      	threesText1.setVisible(false);
       	foursText1.setVisible(false);
       	fivesText1.setVisible(false);
       	sixesText1.setVisible(false);
       	three_of_a_kind_text1.setVisible(false);
       	four_of_a_kind_text1.setVisible(false);
       	full_house_text1.setVisible(false);
       	small_straight_text1.setVisible(false);
       	large_straight_text1.setVisible(false);
       	yatzeeText1.setVisible(false);
       	chanceText1.setVisible(false);
       
       if(numberOfPlayers >= 2){
       	onesText2.setVisible(false);
       	twosText2.setVisible(false);
       	threesText2.setVisible(false);
       	foursText2.setVisible(false);
       	fivesText2.setVisible(false);
       	sixesText2.setVisible(false);
       	three_of_a_kind_text2.setVisible(false);
       	four_of_a_kind_text2.setVisible(false);
       	full_house_text2.setVisible(false);
       	small_straight_text2.setVisible(false);
       	large_straight_text2.setVisible(false);
       	yatzeeText2.setVisible(false);
       	chanceText2.setVisible(false);
       }
       
       if(numberOfPlayers >= 3){
       	onesText3.setVisible(false);
       	twosText3.setVisible(false);
       	threesText3.setVisible(false);
       	foursText3.setVisible(false);
       	fivesText3.setVisible(false);
       	sixesText3.setVisible(false);
       	three_of_a_kind_text3.setVisible(false);
       	four_of_a_kind_text3.setVisible(false);
       	full_house_text3.setVisible(false);
       	small_straight_text3.setVisible(false);
       	large_straight_text3.setVisible(false);
       	yatzeeText3.setVisible(false);
       	chanceText3.setVisible(false);
       }
       
       if(numberOfPlayers >= 4){
       	onesText4.setVisible(false);
       	twosText4.setVisible(false);
       	threesText4.setVisible(false);
       	foursText4.setVisible(false);
       	fivesText4.setVisible(false);
       	sixesText4.setVisible(false);
       	three_of_a_kind_text4.setVisible(false);
       	four_of_a_kind_text4.setVisible(false);
       	full_house_text4.setVisible(false);
       	small_straight_text4.setVisible(false);
      	large_straight_text4.setVisible(false);
       	yatzeeText4.setVisible(false);
       	chanceText4.setVisible(false);
       }
       
       	
       
       
       	      
       	roller.setVisible(false);
       	//End
       	
       //Sets the visiblity for the Start a New Game button and adds the action listener
       	startNewGame.setVisible(true);
       	startNewGame.addActionListener(this);
       
              
       
     	
     	}
     	
     	   	
     	
		
		//draws the buffer
        p.drawImage(buffer,0,0,this);
        
	} 

    public void actionPerformed( ActionEvent ae ) {
    /* The following comment will explain what is happening throughout the entire
    	actionPerformed method
    	
       Roller Button --
    	This button rolls the dice, turns on all of the action listeners for the scoring 
    	buttons and adds up the count of each dice. Which means it will figure out how many ones
    	twos, threes.....are rolled.
    	
       Ones, Twos, Threes, Fours.....all of the Scoring Buttons
       	These buttons find the total of the Dice by adding up all of their values. It then 
       	shows the score in the appropriate player's text field, changes the number of the 
       	activePlayer (moves to the next player's turn), figures out if the game is over by
       	evaluating wether or not every player has had 13 turns, sets the rollNumber back to zero, 
       	resets the checkboxes, resets the currentValue of the dice, and lastly removes all of the action
       	listeners for the scoring buttons so that there will not be any double scoring issues.
       	
       Play Yatzee Button
       	This button sets the activePlayer to 1, then gets the name of all of the players,
       	then determines how many players will be playing the game, hides all of the text fields
       	for entering the player's names, adds the scoreboard, and makes visible all of the items
       	needed for the game screen.
       	
       Start New Game Button
       	This button makes all of the game screen components not visible, and sets the winning
       	screen value to true and all of the other screens to false.
       	
     
    
    */
    
        Object source = ae.getSource();
        
        if (source.equals(roller)) {
        	System.out.println("Rolling the Dice");
        	
        	if(rollNumber<3){
        	
        	if(rollNumber == 0){
        	ones.addActionListener(this);
       		twos.addActionListener(this);
      		threes.addActionListener(this);
       		fours.addActionListener(this);
       		fives.addActionListener(this);
       		sixes.addActionListener(this);
       		three_of_a_kind.addActionListener(this);
       		four_of_a_kind.addActionListener(this);
       		full_house.addActionListener(this);
       		small_straight.addActionListener(this);
       		large_straight.addActionListener(this);
       		yatzee.addActionListener(this);
       		chance.addActionListener(this);
       		}
        	
            
            if(zeroCheckbox.getState() == false){      
            Die temp = (Die) diceVector.elementAt(0);
			result0 = temp.rollAndRetrieve();
			}
			if(oneCheckbox.getState() == false){
			Die temp2 = (Die) diceVector.elementAt(1);
			result1 = temp2.rollAndRetrieve();
			}
			if(twoCheckbox.getState() == false){
			Die temp3 = (Die) diceVector.elementAt(2);
			result2 = temp3.rollAndRetrieve();
			}
			if(threeCheckbox.getState() == false){
			Die temp4 = (Die) diceVector.elementAt(3);
			result3 = temp4.rollAndRetrieve();
			}
			if(fourCheckbox.getState() == false){
			Die temp5 = (Die) diceVector.elementAt(4);
			result4 = temp5.rollAndRetrieve();
			}
			
			rollNumber += 1;        
           
			System.out.println(result0);
			System.out.println(result1);
			System.out.println(result2);
			System.out.println(result3);
			System.out.println(result4);
			
			onesCount = 0;
       		twosCount = 0;
       		threesCount = 0;
       		foursCount = 0;
       		fivesCount = 0;
      		sixesCount = 0;
			
			if(result0 == 1){
			onesCount += 1;
			}
			if(result1 == 1){
			onesCount += 1;
			}
			if(result2 == 1){
			onesCount += 1;
			}
			if(result3 == 1){
			onesCount += 1;
			}
			if(result4 == 1){
			onesCount  += 1;
			}
			 
			 if(result0 == 2){
			twosCount += 1;
			}
			if(result1 == 2){
			twosCount += 1;
			}
			if(result2 == 2){
			twosCount += 1;
			}
			if(result3 == 2){
			twosCount += 1;
			}
			if(result4 == 2){
			twosCount  += 1;
			}
			
			if(result0 == 3){
			threesCount += 1;
			}
			if(result1 == 3){
			threesCount += 1;
			}
			if(result2 == 3){
			threesCount += 1;
			}
			if(result3 == 3){
			threesCount += 1;
			}
			if(result4 == 3){
			threesCount  += 1;
			}
			
			if(result0 == 4){
			foursCount += 1;
			}
			if(result1 == 4){
			foursCount += 1;
			}
			if(result2 == 4){
			foursCount += 1;
			}
			if(result3 == 4){
			foursCount += 1;
			}
			if(result4 == 4){
			foursCount  += 1;
			}
			
			if(result0 == 5){
			fivesCount += 1;
			}
			if(result1 == 5){
			fivesCount += 1;
			}
			if(result2 == 5){
			fivesCount += 1;
			}
			if(result3 == 5){
			fivesCount += 1;
			}
			if(result4 == 5){
			fivesCount  += 1;
			}
			
			if(result0 == 6){
			sixesCount += 1;
			}
			if(result1 == 6){
			sixesCount += 1;
			}
			if(result2 == 6){
			sixesCount += 1;
			}
			if(result3 == 6){
			sixesCount += 1;
			}
			if(result4 == 6){
			sixesCount  += 1;
			}
		
      		
            
           	}            
           
            }
    //Actions Performed when the Ones button is pushed        
        if (source.equals(ones)) {
        	if(result0 == 1){
        	totalOfDice += 1;
        	}
        	if(result1 == 1){
        	totalOfDice += 1;
        	}
        	if(result2 == 1){
        	totalOfDice += 1;
        	}
        	if(result3 == 1){
        	totalOfDice += 1;
        	}
        	if(result4 == 1){
        	totalOfDice += 1;
        	}
        	
        	System.out.println("activePlayer = " + activePlayer);
        	if(activePlayer == 1){
        	onesText1.setText(String.valueOf(totalOfDice));
        	totalforones1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	System.out.println("activePlayer = " + activePlayer);
        	if(activePlayer == 2){
        	onesText2.setText(String.valueOf(totalOfDice));
        	totalforones2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	System.out.println("activePlayer = " + activePlayer);
        	if(activePlayer == 3){
        	onesText3.setText(String.valueOf(totalOfDice));
        	totalforones3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	System.out.println("activePlayer = " + activePlayer);
        	if(activePlayer == 4){
        	onesText4.setText(String.valueOf(totalOfDice));
        	totalforones4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	    
        	    
        	System.out.println("activePlayer = " + activePlayer);
        	System.out.println("numberOfPlayers = " + numberOfPlayers);
    		
    		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    	
    		
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	       	
        	
        	System.out.println("activePlayer = " + activePlayer);
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die dietemp = (Die) diceVector.elementAt(l);
        	dietemp.setCurrentValue(1);
        	System.out.println("Setting Dice to Value 1");
        	}
        	totalOfDice = 0;
        	System.out.println("totalOfDice = " + totalOfDice);
        	
        	        	
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
  }      	
 //Actions Performed when the Twos button is pushed       	
        	if (source.equals(twos)) {
        	if(result0 == 2){
        	totalOfDice += 2;
        	}
        	if(result1 == 2){
        	totalOfDice += 2;
        	}
        	if(result2 == 2){
        	totalOfDice += 2;
        	}
        	if(result3 == 2){
        	totalOfDice += 2;
        	}
        	if(result4 == 2){
        	totalOfDice += 2;
        	}
        	
        	if(activePlayer == 1){
        	twosText1.setText(String.valueOf(totalOfDice));
        	totalfortwos1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	twosText2.setText(String.valueOf(totalOfDice));
        	totalfortwos2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	twosText3.setText(String.valueOf(totalOfDice));
        	totalfortwos3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	twosText4.setText(String.valueOf(totalOfDice));
        	totalfortwos4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
 
   				if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
   			
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
  }      	
        	
    //Actions Performed when the Threes button is pushed        
        if (source.equals(threes)) {
        	if(result0 == 3){
        	totalOfDice += 3;
        	}
        	if(result1 == 3){
        	totalOfDice += 3;
        	}
        	if(result2 == 3){
        	totalOfDice += 3;
        	}
        	if(result3 == 3){
        	totalOfDice += 3;
        	}
        	if(result4 == 3){
        	totalOfDice += 3;
        	}
        	
        	if(activePlayer == 1){
        	threesText1.setText(String.valueOf(totalOfDice));
        	totalforthrees1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	threesText2.setText(String.valueOf(totalOfDice));
        	totalforthrees2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	threesText3.setText(String.valueOf(totalOfDice));
        	totalforthrees3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	threesText4.setText(String.valueOf(totalOfDice));
        	totalforthrees4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	    
    			if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0; 
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}    	
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	        	
  }    
  
      //Actions Performed when the Fours button is pushed        
        if (source.equals(fours)) {
        	if(result0 == 4){
        	totalOfDice += 4;
        	}
        	if(result1 == 4){
        	totalOfDice += 4;
        	}
        	if(result2 == 4){
        	totalOfDice += 4;
        	}
        	if(result3 == 4){
        	totalOfDice += 4;
        	}
        	if(result4 == 4){
        	totalOfDice += 4;
        	}
        	
        	if(activePlayer == 1){
        	foursText1.setText(String.valueOf(totalOfDice));
        	totalforfours1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	foursText2.setText(String.valueOf(totalOfDice));
        	totalforfours2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	foursText3.setText(String.valueOf(totalOfDice));
        	totalforfours3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	foursText4.setText(String.valueOf(totalOfDice));
        	totalforfours4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	  
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}  
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }    	
  
      //Actions Performed when the Fives button is pushed        
        if (source.equals(fives)) {
        	if(result0 == 5){
        	totalOfDice += 5;
        	}
        	if(result1 == 5){
        	totalOfDice += 5;
        	}
        	if(result2 == 5){
        	totalOfDice += 5;
        	}
        	if(result3 == 5){
        	totalOfDice += 5;
        	}
        	if(result4 == 5){
        	totalOfDice += 5;
        	}
        	
        	if(activePlayer == 1){
        	fivesText1.setText(String.valueOf(totalOfDice));
        	totalforfives1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	fivesText2.setText(String.valueOf(totalOfDice));
        	totalforfives2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	fivesText3.setText(String.valueOf(totalOfDice));
        	totalforfives3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	fivesText4.setText(String.valueOf(totalOfDice));
        	totalforfives4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	    
    			if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
       
        	
  }  
  
      //Actions Performed when the Sixes button is pushed        
        if (source.equals(sixes)) {
        	if(result0 == 6){
        	totalOfDice += 6;
        	}
        	if(result1 == 6){
        	totalOfDice += 6;
        	}
        	if(result2 == 6){
        	totalOfDice += 6;
        	}
        	if(result3 == 6){
        	totalOfDice += 6;
        	}
        	if(result4 == 6){
        	totalOfDice += 6;
        	}
        	
        	if(activePlayer == 1){
        	sixesText1.setText(String.valueOf(totalOfDice));
        	totalforsixes1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	sixesText2.setText(String.valueOf(totalOfDice));
        	totalforsixes2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	sixesText3.setText(String.valueOf(totalOfDice));
        	totalforsixes3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	sixesText4.setText(String.valueOf(totalOfDice));
        	totalforsixes4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	    
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
  }  
  
      //Actions Performed when the Three of a Kind button is pushed        
        if (source.equals(three_of_a_kind)) {
        	if(onesCount >= 3 || twosCount >= 3 || threesCount >=3 || foursCount >= 3 || fivesCount >= 3 || sixesCount >= 3){
        	totalOfDice = result0 + result1 + result2 + result3 + result4;
        	}
        	else{ 
        	totalOfDice = 0;
        	}
        	
        	
        	if(activePlayer == 1){
        	three_of_a_kind_text1.setText(String.valueOf(totalOfDice));
        	totalforthree_of_a_kind1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	three_of_a_kind_text2.setText(String.valueOf(totalOfDice));
        	totalforthree_of_a_kind2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	three_of_a_kind_text3.setText(String.valueOf(totalOfDice));
        	totalforthree_of_a_kind3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	three_of_a_kind_text4.setText(String.valueOf(totalOfDice));
        	totalforthree_of_a_kind4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
 			       	    
    			if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
  
      //Actions Performed when the Four of a Kind button is pushed        
        if (source.equals(four_of_a_kind)) {
        	if(onesCount >= 4 || twosCount >= 4 || threesCount >=4 || foursCount >= 4 || fivesCount >= 4 || sixesCount >= 4){
        	totalOfDice = result0 + result1 + result2 + result3 + result4;
        	}
        	else{ 
        	totalOfDice = 0;
        	}
        	
        	if(activePlayer == 1){
        	four_of_a_kind_text1.setText(String.valueOf(totalOfDice));
        	totalforfour_of_a_kind1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	four_of_a_kind_text2.setText(String.valueOf(totalOfDice));
        	totalforfour_of_a_kind2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	four_of_a_kind_text3.setText(String.valueOf(totalOfDice));
        	totalforfour_of_a_kind3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	four_of_a_kind_text4.setText(String.valueOf(totalOfDice));
        	totalforfour_of_a_kind4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
  }  
  
      
  
      //Actions Performed when the Full House button is pushed        
        if (source.equals(full_house)) {
        System.out.println("" + onesCount);
        System.out.println("" + twosCount);
        System.out.println("" + threesCount);
        System.out.println("" + foursCount);
        System.out.println("" + fivesCount);
        System.out.println("" + sixesCount);
        
        	if(onesCount == 3 || twosCount == 3 || threesCount == 3 || foursCount == 3 || fivesCount == 3 || sixesCount == 3
        	&& onesCount == 2 || twosCount == 2 || threesCount == 2 || foursCount == 2 || fivesCount == 2 || sixesCount == 2 ){
        	totalOfDice = 25;
        	}
        	else{ 
        	totalOfDice = 0;
        	}
      
        	
        	if(activePlayer == 1){
        	full_house_text1.setText(String.valueOf(totalOfDice));
        	totalforfull_house1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	full_house_text2.setText(String.valueOf(totalOfDice));
        	totalforfull_house2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	full_house_text3.setText(String.valueOf(totalOfDice));
        	totalforfull_house3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	full_house_text4.setText(String.valueOf(totalOfDice));
        	totalforfull_house4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
  
      //Actions Performed when the Small Straight button is pushed        
        if (source.equals(small_straight)) {
        	if(onesCount >= 1 && twosCount >= 1 && threesCount >= 1 && foursCount >= 1
        	|| twosCount >= 1 && threesCount >= 1 && foursCount >= 1 && fivesCount >= 1
        	|| threesCount >= 1 && foursCount >= 1 && fivesCount >= 1 && sixesCount >= 1){
        	totalOfDice = 30;
        	}
        	else{ 
        	totalOfDice = 0;
        	}
        
        	if(activePlayer == 1){
        	small_straight_text1.setText(String.valueOf(totalOfDice));
        	totalforsmall_straight1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	small_straight_text2.setText(String.valueOf(totalOfDice));
        	totalforsmall_straight2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	small_straight_text3.setText(String.valueOf(totalOfDice));
        	totalforsmall_straight3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	small_straight_text4.setText(String.valueOf(totalOfDice));
        	totalforsmall_straight4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
  
      //Actions Performed when the Large Straight button is pushed        
        if (source.equals(large_straight)){
        	if(onesCount == 1 && twosCount == 1 && threesCount == 1 && foursCount == 1 && fivesCount == 1
        	|| twosCount == 1 && threesCount == 1 && foursCount == 1 && fivesCount == 1 && sixesCount == 1){
        	totalOfDice = 40;
        	}
        	else{ 
        	totalOfDice = 0;
        	}
        
        	if(activePlayer == 1){
        	large_straight_text1.setText(String.valueOf(totalOfDice));
        	totalforlarge_straight1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	large_straight_text2.setText(String.valueOf(totalOfDice));
        	totalforlarge_straight2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	large_straight_text3.setText(String.valueOf(totalOfDice));
        	totalforlarge_straight3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	large_straight_text4.setText(String.valueOf(totalOfDice));
        	totalforlarge_straight4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
  
      //Actions Performed when the Yatzee button is pushed        
        if (source.equals(yatzee)) {
        	if(onesCount == 5 || twosCount == 5 || threesCount == 5 || foursCount == 5 || fivesCount == 5 || sixesCount == 5){
        	totalOfDice = 50;
        	}
        	else{
        	totalOfDice = 0;
        	}
        	
        	if(activePlayer == 1){
        	yatzeeText1.setText(String.valueOf(totalOfDice));
        	totalforyatzee1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	yatzeeText2.setText(String.valueOf(totalOfDice));
        	totalforyatzee2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	yatzeeText3.setText(String.valueOf(totalOfDice));
        	totalforyatzee3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	yatzeeText4.setText(String.valueOf(totalOfDice));
        	totalforyatzee4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
  
      //Actions Performed when the Chance button is pushed        
        if (source.equals(chance)) {
        
        	totalOfDice = result0 + result1 + result2 + result3 + result4;
        	
        	
        	if(activePlayer == 1){
        	chanceText1.setText(String.valueOf(totalOfDice));
        	totalforchance1 = totalOfDice;
        	playerOneTotal = scoreboard.CalculatePoints(totalforones1, totalfortwos1, totalforthrees1, totalforfours1, totalforfives1, totalforsixes1, totalforthree_of_a_kind1, totalforfour_of_a_kind1, totalforfull_house1, totalforsmall_straight1, totalforlarge_straight1, totalforyatzee1, totalforchance1);
        	scoreboard.setplayerOneScore(playerOneTotal);
        	}
        	if(activePlayer == 2){
        	chanceText2.setText(String.valueOf(totalOfDice));
        	totalforchance2 = totalOfDice;
        	playerTwoTotal = scoreboard.CalculatePoints(totalforones2, totalfortwos2, totalforthrees2, totalforfours2, totalforfives2, totalforsixes2, totalforthree_of_a_kind2, totalforfour_of_a_kind2, totalforfull_house2, totalforsmall_straight2, totalforlarge_straight2, totalforyatzee2, totalforchance2);
        	scoreboard.setplayerTwoScore(playerTwoTotal);
        	}
        	if(activePlayer == 3){
        	chanceText3.setText(String.valueOf(totalOfDice));
        	totalforchance3 = totalOfDice;
        	playerThreeTotal = scoreboard.CalculatePoints(totalforones3, totalfortwos3, totalforthrees3, totalforfours3, totalforfives3, totalforsixes3, totalforthree_of_a_kind3, totalforfour_of_a_kind3, totalforfull_house3, totalforsmall_straight3, totalforlarge_straight3, totalforyatzee3, totalforchance3);
        	scoreboard.setplayerThreeScore(playerThreeTotal);
        	}
        	if(activePlayer == 4){
        	chanceText4.setText(String.valueOf(totalOfDice));
        	totalforchance4 = totalOfDice;
        	playerFourTotal = scoreboard.CalculatePoints(totalforones4, totalfortwos4, totalforthrees4, totalforfours4, totalforfives4, totalforsixes4, totalforthree_of_a_kind4, totalforfour_of_a_kind4, totalforfull_house4, totalforsmall_straight4, totalforlarge_straight4, totalforyatzee4, totalforchance4);
        	scoreboard.setplayerFourScore(playerFourTotal);
        	}
        	
        		if(activePlayer == 1){
    		onePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		twoPlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		threePlayerTurnCount++;
    		}
    		if(activePlayer == 2){
    		fourPlayerTurnCount++;
    		}
    		
    		if(numberOfPlayers == 1 && onePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 2 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 3 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
    		if(numberOfPlayers == 4 && onePlayerTurnCount == 13 && twoPlayerTurnCount == 13 && threePlayerTurnCount == 13 && fourPlayerTurnCount == 13){
    		openingScreen = false;
    		gameScreen = false;
    		winningScreen = true;
    		winningPlayerName = scoreboard.findWinningPlayer();
    		int r;
        	for(r=0; r<diceVector.size(); r++){
        	Die dietemp2 = (Die) diceVector.elementAt(r);
        	dietemp2.makeInvisible();
        	}
    		}
        	    
    
        	activePlayer++;
        	
        	if(activePlayer > numberOfPlayers){
        	activePlayer = 1;
        	}
        	
        	rollNumber = 0;
        	zeroCheckbox.setState(false);
        	oneCheckbox.setState(false);
        	twoCheckbox.setState(false);
        	threeCheckbox.setState(false);
        	fourCheckbox.setState(false);
        	int l;
        	for(l=0;l<diceVector.size();l++){
        	Die temp = (Die) diceVector.elementAt(l);
        	temp.setCurrentValue(1);
        	}
        	totalOfDice = 0;
        	
        	ones.removeActionListener(this);
       		twos.removeActionListener(this);
       		threes.removeActionListener(this);
       		fours.removeActionListener(this);
       		fives.removeActionListener(this);
       		sixes.removeActionListener(this);
       		three_of_a_kind.removeActionListener(this);
       		four_of_a_kind.removeActionListener(this);
       		full_house.removeActionListener(this);
      		small_straight.removeActionListener(this);
       		large_straight.removeActionListener(this);
       		yatzee.removeActionListener(this);
       		chance.removeActionListener(this);
        	
        	
  }  
   //Play Yatzee Button Actions     
        if (source.equals(playYatzee)) {
        
       activePlayer = 1; 
        
       playerOneName = name_of_player_one.getText();
       playerTwoName = name_of_player_two.getText();
       playerThreeName = name_of_player_three.getText();
       playerFourName = name_of_player_four.getText();
       
       if(number_of_players.getSelectedIndex() == 0){
       numberOfPlayers = 1;
       }
        if(number_of_players.getSelectedIndex() == 1){
       numberOfPlayers = 2;
       }
        if(number_of_players.getSelectedIndex() == 2){
       numberOfPlayers = 3;
       }
        if(number_of_players.getSelectedIndex() == 3){
       numberOfPlayers = 4;
       }
       System.out.println("number of players " + numberOfPlayers);
       System.out.println(playerOneName);
       System.out.println(playerTwoName);
       System.out.println(playerThreeName);
       System.out.println(playerFourName);
        
       name_of_player_one.setVisible(false);
       name_of_player_two.setVisible(false);
       name_of_player_three.setVisible(false);
       name_of_player_four.setVisible(false);

       
       playYatzee.setVisible(false);
       number_of_players.setVisible(false);
       openingLabel.setVisible(false);

             
       
       if(numberOfPlayers == 1){
       scoreboard = new Scoring(numberOfPlayers, playerOneName, 0);
       }
       if(numberOfPlayers == 2){
       scoreboard = new Scoring(numberOfPlayers, playerOneName, 0, playerTwoName, 0);
       }
       if(numberOfPlayers == 3){
       scoreboard = new Scoring(numberOfPlayers, playerOneName, 0, playerTwoName, 0, playerThreeName, 0);
       }
       if(numberOfPlayers == 4){
       scoreboard = new Scoring(numberOfPlayers, playerOneName, 0, playerTwoName, 0, playerThreeName, 0, playerFourName, 0);
       }
       
       System.out.println(scoreboard.getoneName());
       System.out.println(scoreboard.getplayerOneScore());
       System.out.println(scoreboard.getnumPlayers());
       
              
       zeroCheckbox.setVisible(true);
       oneCheckbox.setVisible(true);
       twoCheckbox.setVisible(true);
       threeCheckbox.setVisible(true);
       fourCheckbox.setVisible(true);
       roller.setVisible(true);
       
       ones.setVisible(true);
       twos.setVisible(true);
       threes.setVisible(true);
       fours.setVisible(true);
       fives.setVisible(true);
       sixes.setVisible(true);
       three_of_a_kind.setVisible(true);
       four_of_a_kind.setVisible(true);
       full_house.setVisible(true);
       small_straight.setVisible(true);
       large_straight.setVisible(true);
       yatzee.setVisible(true);
       chance.setVisible(true);
       
       
       onesText1.setVisible(true);
       twosText1.setVisible(true);
       threesText1.setVisible(true);
       foursText1.setVisible(true);
       fivesText1.setVisible(true);
       sixesText1.setVisible(true);
       three_of_a_kind_text1.setVisible(true);
       four_of_a_kind_text1.setVisible(true);
       full_house_text1.setVisible(true);
       small_straight_text1.setVisible(true);
       large_straight_text1.setVisible(true);
       yatzeeText1.setVisible(true);
       chanceText1.setVisible(true);
       
       if(numberOfPlayers >= 2){
       onesText2.setVisible(true);
       twosText2.setVisible(true);
       threesText2.setVisible(true);
       foursText2.setVisible(true);
       fivesText2.setVisible(true);
       sixesText2.setVisible(true);
       three_of_a_kind_text2.setVisible(true);
       four_of_a_kind_text2.setVisible(true);
       full_house_text2.setVisible(true);
       small_straight_text2.setVisible(true);
       large_straight_text2.setVisible(true);
       yatzeeText2.setVisible(true);
       chanceText2.setVisible(true);
       }
       
       if(numberOfPlayers >= 3){
       onesText3.setVisible(true);
       twosText3.setVisible(true);
       threesText3.setVisible(true);
       foursText3.setVisible(true);
       fivesText3.setVisible(true);
       sixesText3.setVisible(true);
       three_of_a_kind_text3.setVisible(true);
       four_of_a_kind_text3.setVisible(true);
       full_house_text3.setVisible(true);
       small_straight_text3.setVisible(true);
       large_straight_text3.setVisible(true);
       yatzeeText3.setVisible(true);
       chanceText3.setVisible(true);
       }
       
       if(numberOfPlayers >= 4){
       onesText4.setVisible(true);
       twosText4.setVisible(true);
       threesText4.setVisible(true);
       foursText4.setVisible(true);
       fivesText4.setVisible(true);
       sixesText4.setVisible(true);
       three_of_a_kind_text4.setVisible(true);
       four_of_a_kind_text4.setVisible(true);
       full_house_text4.setVisible(true);
       small_straight_text4.setVisible(true);
       large_straight_text4.setVisible(true);
       yatzeeText4.setVisible(true);
       chanceText4.setVisible(true);
       }
       
       int r;
       for(r=0; r<diceVector.size(); r++){
       Die dietemp2 = (Die) diceVector.elementAt(r);
       dietemp2.makeVisible();
       }
       
       totalforones1 = 0;
       totalfortwos1 = 0;
       totalforthrees1 = 0;
       totalforfours1 = 0;
       totalforfives1 = 0;
       totalforsixes1 = 0;
       totalforthree_of_a_kind1 = 0;
       totalforfour_of_a_kind1 = 0;
       totalforfull_house1 = 0;
       totalforsmall_straight1 = 0;
       totalforlarge_straight1 = 0;
       totalforyatzee1 = 0;
       totalforchance1 = 0;
       
       totalforones2 = 0;
       totalfortwos2 = 0;
       totalforthrees2 = 0;
       totalforfours2 = 0;
       totalforfives2 = 0;
       totalforsixes2 = 0;
       totalforthree_of_a_kind2 = 0;
       totalforfour_of_a_kind2 = 0;
       totalforfull_house2 = 0;
       totalforsmall_straight2 = 0;
       totalforlarge_straight2 = 0;
       totalforyatzee2 = 0;
       totalforchance2 = 0;
       
       totalforones3 = 0;
       totalfortwos3 = 0;
       totalforthrees3 = 0;
       totalforfours3 = 0;
       totalforfives3 = 0;
       totalforsixes3 = 0;
       totalforthree_of_a_kind3 = 0;
       totalforfour_of_a_kind3 = 0;
       totalforfull_house3 = 0;
       totalforsmall_straight3 = 0;
       totalforlarge_straight3 = 0;
       totalforyatzee3 = 0;
       totalforchance3 = 0;
       
       totalforones4 = 0;
       totalfortwos4 = 0;
       totalforthrees4 = 0;
       totalforfours4 = 0;
       totalforfives4 = 0;
       totalforsixes4 = 0;
       totalforthree_of_a_kind4 = 0;
       totalforfour_of_a_kind4 = 0;
       totalforfull_house4 = 0;
       totalforsmall_straight4 = 0;
       totalforlarge_straight4 = 0;
       totalforyatzee4 = 0;
       totalforchance4 = 0; 
       
             	
   
       openingScreen = false;
       gameScreen = true;
       winningScreen = false;
       
           
        
       }
       
       
       if (source.equals(startNewGame)) { 
       
       startNewGame.setVisible(false);
       openingLabel.setVisible(true);
       number_of_players.setVisible(true);
       name_of_player_one.setVisible(true);
       name_of_player_two.setVisible(true);
       name_of_player_three.setVisible(true);
       name_of_player_four.setVisible(true);
       playYatzee.setVisible(true);
       playYatzee.addActionListener(this);
       openingScreen = true;
       gameScreen = false; 
       winningScreen = false;
       
       
       onesText1.setText("");
       twosText1.setText("");
       threesText1.setText("");
       foursText1.setText("");
       fivesText1.setText("");
       sixesText1.setText("");
       three_of_a_kind_text1.setText("");
       four_of_a_kind_text1.setText("");
       full_house_text1.setText("");
       small_straight_text1.setText("");
       large_straight_text1.setText("");
       yatzeeText1.setText("");
       chanceText1.setText("");
       
       onesText2.setText("");
       twosText2.setText("");
       threesText2.setText("");
       foursText2.setText("");
       fivesText2.setText("");
       sixesText2.setText("");
       three_of_a_kind_text2.setText("");
       four_of_a_kind_text2.setText("");
       full_house_text2.setText("");
       small_straight_text2.setText("");
       large_straight_text2.setText("");
       yatzeeText2.setText("");
       chanceText2.setText("");
       
       onesText3.setText("");
       twosText3.setText("");
       threesText3.setText("");
       foursText3.setText("");
       fivesText3.setText("");
       sixesText3.setText("");
       three_of_a_kind_text3.setText("");
       four_of_a_kind_text3.setText("");
       full_house_text3.setText("");
       small_straight_text3.setText("");
       large_straight_text3.setText("");
       yatzeeText3.setText("");
       chanceText3.setText("");
       
       onesText4.setText("");
       twosText4.setText("");
       threesText4.setText("");
       foursText4.setText("");
       fivesText4.setText("");
       sixesText4.setText("");
       three_of_a_kind_text4.setText("");
       four_of_a_kind_text4.setText("");
       full_house_text4.setText("");
       small_straight_text4.setText("");
       large_straight_text4.setText("");
       yatzeeText4.setText("");
       chanceText4.setText("");
       
       playerOneName = "Nom du joueur 1";
       playerTwoName = "Nom du joueur 2";
       playerThreeName = "Nom du joueur 3";
       playerFourName = "Nom du joueur 4";
       
       
       
       }
        
        
        repaint();
    } 
    
//Dice Class
public class Die extends Canvas {
	
	//creates the private data members for the class
    private int currentValue;
    private int x, y, size;
    
    //contructor for the Die class
    public Die (int x, int y, int size) {
        this.x = x;
        this.y = y;
        this.size = size;
        currentValue = 1;
        setBounds(x, y, size+2, size+2);  
        
        
    } 
    //makes the die invisible
    public void makeInvisible(){
    	setBounds(0,0,0,0);
    	
    }
    //makes the die visible
    public void makeVisible(){
    	setBounds(x,y, size+2, size+2);
    	
    	repaint();
    }
    
    //gets the current value of the die
    public int getCurrentValue() {
        return currentValue;
    } 
    
    //sets the current value of the die
    public void setCurrentValue(int currentValue){
 		this.currentValue = currentValue;
 		
 		repaint();
 	}   
     
    //rolls the die 
    public void roll() {
        currentValue = (int) (Math.random()*6) + 1; 
        
        repaint();  
    } 
    
    //rolls and retrieves the die's value
    public int rollAndRetrieve() {
        roll();
        return getCurrentValue();
    }  
    
    //paints the die on the screen
    public void paint( Graphics g ) {
        g.setColor(Color.white);
        g.fillRoundRect(0, 0, size, size, size/8, size/8);
        g.setColor(Color.black);
        g.drawRoundRect(0, 0, size, size, size/8, size/8);

        int dotSize = size/6;
        
        int leftDotX   = size/4 - dotSize/2;
        int middleDotX = size/2 - dotSize/2;
        int rightDotX  = 3*size/4 - dotSize/2;
        
        int topDotY    = size/4 - dotSize/2;
        int middleDotY = size/2 - dotSize/2;
        int bottomDotY = 3*size/4 - dotSize/2;
                
        switch (currentValue) {
            case 5: g.fillOval(leftDotX, topDotY, dotSize, dotSize);
                    g.fillOval(rightDotX, bottomDotY, dotSize, dotSize);
            case 3: g.fillOval(leftDotX, bottomDotY, dotSize, dotSize);
                    g.fillOval(rightDotX, topDotY, dotSize, dotSize);
            case 1: g.fillOval(middleDotX, middleDotY, dotSize, dotSize); break;
            
            case 6: g.fillOval(leftDotX, middleDotY, dotSize, dotSize);
                    g.fillOval(rightDotX, middleDotY, dotSize, dotSize);
            case 4: g.fillOval(rightDotX, bottomDotY, dotSize, dotSize);
                    g.fillOval(leftDotX, topDotY, dotSize, dotSize);
            case 2: g.fillOval(leftDotX, bottomDotY, dotSize, dotSize);
                    g.fillOval(rightDotX, topDotY, dotSize, dotSize);
        }
                
    } 
    
}

//the Scoring class
	public class Scoring{

				//declaring private data members
				private int playerOneScore, playerTwoScore, playerThreeScore, playerFourScore;
				private int numPlayers;
				private int ones_points, twos_points, threes_points, fours_points, fives_points, sixes_points, three_of_a_kind_points, four_of_a_kind_points, full_house_points, small_straight_points, large_straight_points, yatzee_points, chance_points;
				private String oneName;
				private String twoName;
				private String threeName;
				private String fourName;
				
				
				
				
	//sets the players names and scores for one player
	public Scoring(int numPlayers, String oneName, int playerOneScore){			
				this.numPlayers = numPlayers;
				this.playerOneScore = playerOneScore;
				this.oneName = oneName;
				
	}
	//sets the players names and scores for two players
	public Scoring(int numPlayers, String oneName, int playerOneScore, String twoName, int playerTwoScore){			
				this.numPlayers = numPlayers;
				this.playerOneScore = playerOneScore;
				this.playerTwoScore = playerTwoScore;
				this.oneName = oneName;
				this.twoName = twoName;
				
	}
	//sets the players names and scores for three players
	public Scoring(int numPlayers, String oneName, int playerOneScore, String twoName, int playerTwoScore, String threeName, int playerThreeScore){			
				this.numPlayers = numPlayers;
				this.playerOneScore = playerOneScore;
				this.playerTwoScore = playerTwoScore;
				this.playerThreeScore = playerThreeScore;
				this.oneName = oneName;
				this.twoName = twoName;
				this.threeName = threeName;
				
	}
	//sets the players names and scores for four players
	public Scoring(int numPlayers, String oneName, int playerOneScore, String twoName, int playerTwoScore, String threeName, int playerThreeScore, String fourName, int playerFourScore){			
				this.numPlayers = numPlayers;
				this.playerOneScore = playerOneScore;
				this.playerTwoScore = playerTwoScore;
				this.playerThreeScore = playerThreeScore;
				this.playerFourScore = playerFourScore;
				this.oneName = oneName;
				this.twoName = twoName;
				this.threeName = threeName;
				this.fourName = fourName;
				
	}
	//calculates the total number of points for a player
	public int CalculatePoints(int ones_points, int twos_points, int threes_points, int fours_points, int fives_points, int sixes_points, int three_of_a_kind_points, int four_of_a_kind_points, int full_house_points, int small_straight_points, int large_straight_points, int yatzee_points, int chance_points){
				this.ones_points = ones_points;
				this.twos_points = twos_points;
				this.threes_points = threes_points;
				this.fours_points = fours_points;
				this.fives_points = fives_points;
				this.sixes_points = sixes_points;
				this.three_of_a_kind_points = three_of_a_kind_points;
				this.four_of_a_kind_points = four_of_a_kind_points;
				this.full_house_points = full_house_points;
				this.small_straight_points = small_straight_points;
				this.large_straight_points = large_straight_points;
				this.yatzee_points = yatzee_points;
				this.chance_points = chance_points;
				
				int total_number_of_points;
				
				total_number_of_points = ones_points + twos_points + threes_points + fours_points + fives_points + sixes_points + three_of_a_kind_points + four_of_a_kind_points + full_house_points + small_straight_points + large_straight_points + yatzee_points + chance_points;
				
				return total_number_of_points;
				
	 	}
	 	
	//finds the winning player of the game 	
	public String findWinningPlayer(){
		boolean playerOneWon = false;
		boolean playerTwoWon = false;
		boolean playerThreeWon = false;
		boolean playerFourWon = false;
		
		String answer = new String("");
	
		if(playerOneScore > playerTwoScore && playerOneScore > playerThreeScore &&  playerOneScore > playerFourScore){
		playerOneWon = true;
		}
		if(playerTwoScore > playerOneScore && playerTwoScore > playerThreeScore && playerTwoScore > playerFourScore){
		playerTwoWon = true;
		}
		if(playerThreeScore > playerOneScore && playerThreeScore > playerTwoScore && playerThreeScore > playerFourScore){
		playerThreeWon = true;
		}
		if(playerFourScore > playerOneScore && playerFourScore > playerTwoScore && playerFourScore > playerThreeScore){
		playerFourWon = true;
		}
		
		if(playerOneWon == true){
		answer = oneName;
		}
		if(playerTwoWon == true){
		answer = twoName;
		}
		if(playerThreeWon == true){
		answer = threeName;
		}
		if(playerFourWon == true){
		answer = fourName;
		}
		
		return answer;	
		
		}			
				
	//gets playerOne's name			
	public String getoneName(){
	    		
	    		return oneName;
	    
	    }	
	//gets playerTwo's name    
	public String gettwoName(){
	    		
	    		return twoName;
	    
	    }
	
	//gets playerThree's name
	public String getthreeName(){
	    		
	    		return threeName;
	    
	    }
	//gets playerFour's name    
	public String getfourName(){
	    		
	    		return fourName;
	    
	    }		
	
	//gets playerOne's score    
	public int getplayerOneScore(){
				
				return playerOneScore;
				
		}
	
	//gets the number of players	
	public int getnumPlayers(){
	
				return numPlayers;
				
		}    
				
	//Start - sets everyone's score			
	
	public void setplayerOneScore(int playerOneScore){
	
				this.playerOneScore = playerOneScore;
				
				}

	public void setplayerTwoScore(int playerTwoScore){
	
				this.playerTwoScore = playerTwoScore;
				
				}
				
	public void setplayerThreeScore(int playerThreeScore){
	
				this.playerThreeScore = playerThreeScore;
				
				}			
				
	public void setplayerFourScore(int playerFourScore){
	
				this.playerFourScore = playerFourScore;
				
				}			
				
	//End
				
		
	//draws the scoring board
	public void drawScoreBoard(Graphics pad){
				
				System.out.println("drawing scoreboard");
				pad.setColor(Color.black);
				System.out.println("numPlayers = " + numPlayers);
				if(numPlayers == 1){
				pad.drawString(oneName,295,195);
				pad.drawString(String.valueOf(playerOneScore), 475, 195);
				pad.drawString("P1", 168, 115);
				}
				if(numPlayers == 2){
				pad.drawString(oneName,295,195);
				pad.drawString(String.valueOf(playerOneScore), 475, 195);
				pad.drawString("P1", 168, 115);
				pad.drawString(twoName,295,215);
				pad.drawString(String.valueOf(playerTwoScore), 475, 215);
				pad.drawString("P2", 198, 115);
				}
				if(numPlayers == 3){
				pad.drawString(oneName,295,195);
				pad.drawString(String.valueOf(playerOneScore), 475, 195);
				pad.drawString("P1", 168, 115);
				pad.drawString(twoName,295,215);
				pad.drawString(String.valueOf(playerTwoScore), 475, 215);
				pad.drawString("P2", 198, 115);
				pad.drawString(threeName,295,235);
				pad.drawString(String.valueOf(playerThreeScore), 475, 235);
				pad.drawString("P3", 228, 115);
				}
				if(numPlayers == 4){
				pad.drawString(oneName,295,195);
				pad.drawString(String.valueOf(playerOneScore), 475, 195);
				pad.drawString("P1", 168, 115);
				pad.drawString(twoName,295,215);
				pad.drawString(String.valueOf(playerTwoScore), 475, 215);
				pad.drawString("P2", 198, 115);
				pad.drawString(threeName,295,235);
				pad.drawString(String.valueOf(playerThreeScore), 475, 235);
				pad.drawString("P3", 228, 115);
				pad.drawString(fourName,295,255);
				pad.drawString(String.valueOf(playerFourScore), 475, 255);
				pad.drawString("P4", 258, 115);
				}
				pad.drawString("Nom", 295, 165);
				pad.drawString("Score", 465, 165);
				pad.drawLine(295, 171, 495, 171);
				
				
				
				
	
	}
				
}				

}


